openshot::Blur Class Reference

This class adjusts the blur of an image, and can be animated with openshot::Keyframe curves over time. More...

`#include <Blur.h>`

Inheritance diagram for openshot::Blur:

## Public Member Functions

| Blur ()
| Blank constructor, useful when using Json to load the effect properties. More...
| Blur (Keyframe new_horizontal_radius, Keyframe new_vertical_radius, Keyframe new_sigma, Keyframe new_iterations)
std::shared_ptr< Frame > | GetFrame (std::shared_ptr< Frame > frame, int64_t frame_number)
| This method is required for all derived classes of EffectBase, and returns a modified openshot::Frame object. More...
string | Json ()
| Get and Set JSON methods. More...
Json::Value | JsonValue ()
| Generate Json::JsonValue for this object. More...
string | PropertiesJSON (int64_t requested_frame)
void | SetJson (string value)
| Load JSON string into this object. More...
void | SetJsonValue (Json::Value root)
| Load Json::JsonValue into this object. More...
Public Member Functions inherited from openshot::EffectBase
void | DisplayInfo ()
| Display effect information in the standard output stream (stdout) More...
void | InitEffectInfo ()
Json::Value | JsonInfo ()
| Generate JSON object of meta data / info. More...
int | Order ()
| Get the order that this effect should be executed. More...
void | Order (int new_order)
| Set the order that this effect should be executed. More...
Public Member Functions inherited from openshot::ClipBase
| ClipBase ()
| Constructor for the base clip. More...
float | Duration ()
| Get the length of this clip (in seconds) More...
float | End ()
| Get end position (in seconds) of clip (trim end of video) More...
void | End (float value)
| Set end position (in seconds) of clip (trim end of video) More...
string | Id ()
| Get basic properties. More...
void | Id (string value)
| Set basic properties. More...
int | Layer ()
| Get layer of clip on timeline (lower number is covered by higher numbers) More...
void | Layer (int value)
| Set layer of clip on timeline (lower number is covered by higher numbers) More...
bool | operator< (ClipBase &a)
bool | operator<= (ClipBase &a)
bool | operator> (ClipBase &a)
bool | operator>= (ClipBase &a)
float | Position ()
| Get position on timeline (in seconds) More...
void | Position (float value)

> Set the Id of this clip object

More...

void | SetMaxSize (int width, int height)
| Set Max Image Size (used for performance optimization) More...
float | Start ()
| Get start position (in seconds) of clip (trim start of video) More...
void | Start (float value)
| Set start position (in seconds) of clip (trim start of video) More...

## Public Attributes

Keyframe | horizontal_radius
| Horizontal blur radius keyframe. The size of the horizontal blur operation in pixels. More...
Keyframe | iterations
| Iterations keyframe. The # of blur iterations per pixel. 3 iterations = Gaussian. More...
Keyframe | sigma
| Sigma keyframe. The amount of spread in the blur operation. Should be larger than radius. More...
Keyframe | vertical_radius
| Vertical blur radius keyframe. The size of the vertical blur operation in pixels. More...
Public Attributes inherited from openshot::EffectBase
EffectInfoStruct | info
| Information about the current effect. More...

## Additional Inherited Members

Protected Member Functions inherited from openshot::ClipBase
Json::Value | add_property_choice_json (string name, int value, int selected_value)
| Generate JSON choice for a property (dropdown properties) More...
Json::Value | add_property_json (string name, float value, string type, string memo, Keyframe *keyframe, float min_value, float max_value, bool readonly, int64_t requested_frame)
| Generate JSON for a property. More...
Protected Attributes inherited from openshot::ClipBase
float | end
| The position in seconds to end playing (used to trim the ending of a clip) More...
string | id
| ID Property for all derived Clip and Effect classes. More...
int | layer
| The layer this clip is on. Lower clips are covered up by higher clips. More...
int | max_height
| The maximium image height needed by this clip (used for optimizations) More...
int | max_width
| The maximum image width needed by this clip (used for optimizations) More...
float | position
| The position on the timeline where this clip should start playing. More...
string | previous_properties
| This string contains the previous JSON properties. More...
float | start
| The position in seconds to start playing (used to trim the beginning of a clip) More...

## Detailed Description

This class adjusts the blur of an image, and can be animated with openshot::Keyframe curves over time.

Adjusting the blur of an image over time can create many different powerful effects. To achieve a box blur effect, use identical horizontal and vertical blur values. To achieve a Gaussian blur, use 3 iterations, a sigma of 3.0, and a radius between 3 and X (depending on how much blur you want).

Definition at line 62 of file Blur.h.

## Constructor & Destructor Documentation

## Blur() [1/2]

Blur::Blur | ( |  | ) |

Blank constructor, useful when using Json to load the effect properties.

Definition at line 33 of file Blur.cpp.

## Blur() [2/2]

Blur::Blur | ( | Keyframe | new_horizontal_radius,
|  | Keyframe | new_vertical_radius,
|  | Keyframe | new_sigma,
|  | Keyframe | new_iterations
| ) |  |

Default constructor, which takes 1 curve. The curve adjusts the blur radius of a frame's image.

Parameters

  new_horizontal_radius | The curve to adjust the horizontal blur radius (between 0 and 100, rounded to int)
  new_vertical_radius | The curve to adjust the vertical blur radius (between 0 and 100, rounded to int)
  new_sigma | The curve to adjust the sigma amount (the size of the blur brush (between 0 and 100), float values accepted)
  new_iterations | The curve to adjust the # of iterations (between 1 and 100)

Definition at line 39 of file Blur.cpp.

## Member Function Documentation

## GetFrame()

std::shared_ptr< Frame > Blur::GetFrame | ( | std::shared_ptr< Frame > | frame,
|  | int64_t | frame_number
| ) |  |

virtual

This method is required for all derived classes of EffectBase, and returns a modified openshot::Frame object.

The frame object is passed into this method, and a frame_number is passed in which tells the effect which settings to use from it's keyframes (starting at 1).

Returns
  The modified openshot::Frame object

Parameters

  frame | The frame object that needs the effect applied to it
  frame_number | The frame number (starting at 1) of the effect on the timeline.

Implements openshot::EffectBase.

Definition at line 63 of file Blur.cpp.

## Json()

string Blur::Json | ( |  | ) |

virtual

Get and Set JSON methods.

Generate JSON string of this object

Implements openshot::EffectBase.

Definition at line 240 of file Blur.cpp.

## JsonValue()

Json::Value Blur::JsonValue | ( |  | ) |

virtual

Generate Json::JsonValue for this object.

Implements openshot::EffectBase.

Definition at line 247 of file Blur.cpp.

## PropertiesJSON()

string Blur::PropertiesJSON | ( | int64_t | requested_frame | ) |

virtual

Get all properties for a specific frame (perfect for a UI to display the current state of all properties at any time)

Implements openshot::ClipBase.

Definition at line 302 of file Blur.cpp.

## SetJson()

void Blur::SetJson | ( | string | value | ) |

virtual

Load JSON string into this object.

Implements openshot::EffectBase.

Definition at line 262 of file Blur.cpp.

## SetJsonValue()

void Blur::SetJsonValue | ( | Json::Value | root | ) |

virtual

Load Json::JsonValue into this object.

Implements openshot::EffectBase.

Definition at line 285 of file Blur.cpp.

## Member Data Documentation

## horizontal_radius

Keyframe openshot::Blur::horizontal_radius

Horizontal blur radius keyframe. The size of the horizontal blur operation in pixels.

Definition at line 75 of file Blur.h.

## iterations

Keyframe openshot::Blur::iterations

Iterations keyframe. The # of blur iterations per pixel. 3 iterations = Gaussian.

Definition at line 78 of file Blur.h.

## sigma

Keyframe openshot::Blur::sigma

Sigma keyframe. The amount of spread in the blur operation. Should be larger than radius.

Definition at line 77 of file Blur.h.

## vertical_radius

Keyframe openshot::Blur::vertical_radius

Vertical blur radius keyframe. The size of the vertical blur operation in pixels.

Definition at line 76 of file Blur.h.

The documentation for this class was generated from the following files:

- Blur.h
- Blur.cpp